\documentclass[a4paper,notitlepage,oneside,]{article}
% \usepackage[a4paper,margin=2.54cm]{geometry}
\usepackage[a4paper]{geometry}
\usepackage[T1]{fontenc}
\usepackage[sfdefault,scaled=.85]{FiraSans}
\usepackage{newtxsf}
\usepackage{framed}
\usepackage[bottom]{footmisc}
%
\usepackage{hyperref}
\usepackage[acronym,toc]{glossaries}
\usepackage{parskip}
\usepackage{graphicx}
\usepackage{tabularx}
\usepackage{float}
\usepackage{enumitem}
\usepackage{fancyhdr}
\begin{document}
\frenchspacing
\pagestyle{fancyplain}
\renewcommand{\footrulewidth}{0.4pt}
\fancyhf{}
\fancyhf[HLE,HLO]{Experiment 2a - Setup eBGP}
\fancyhf[HRE,HRO,FRE,FRO]{\thepage}
\fancyhf[FLE,FLO]{DE-CIX Academy}
\fancyhf[FCE,FCO]{BGP for networks who peer}
\title{Experiment 2a - Setup eBGP}
\date{Version 2.1}
\author{\href{mailto:academy@decix.net}{DE-CIX Academy}}
\maketitle
\section{Introduction}
In this experiment we connect our AS to the outside world. In BGP we talk about eBGP if two different ASes interconnect with each other. This experiment is very simple as you just connect to one other AS and receive a few prefixes.

\section{Network Setup}
\begin{figure}[H]
  \centering
  \includegraphics[width=\linewidth,page=1]{img/02-ebgp-drawings.pdf}
  \caption{Network Setup}
  \label{fig:networksetup}
\end{figure}
Figure \ref{fig:networksetup} shows the network topology for this experiment.
Participants are using AS6450x and are connected to AS65550 as a single upstream.

\section{Slides}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Configure eBGP to upstream AS65550}
\Large
\begin{itemize}
  \item We define empty route-maps
  \item Like in iBGP we put common configs into a peer-group
  \item some defaults are already pre-defined
\end{itemize}
\vspace{0.5cm}

\begin{framed}
\begin{verbatim}
route-map upstream-in permit 100
route-map upstream-out deny 100
!
router bgp 645xx
 neighbor upstream-v4 peer-group
 address-family ipv4 unicast
  neighbor upstream-v4 soft-reconfig inbound
  neighbor upstream-v4 route-map upstream-in in
  neighbor upstream-v4 route-map upstream-out out
  neighbor upstream-v4 activate
 exit-address-family
 neighbor 10.200.xx.1 remote-as 65550
 neighbor 10.200.xx.1 peer-group upstream-v4
\end{verbatim}
\end{framed}

Show commands:
\begin{itemize}
  \item show bgp ipv4 summary
  \item show bgp ipv4 neighbor 10.200.xx.1
  \item show bgp ipv4
  \item show bgp ipv4 neighbor 10.200.xx.1 routes
  \item show bgp ipv4 neighbor 10.200.xx.1 received-routes\\
    \emph{why is one prefix you see not accepted?}
  \item show bgp ipv4 neighbor 10.200.xx.1 advertised-routes
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Configure eBGP for IPv6}
\Large
\begin{itemize}
  \item We use the same route-maps!
  \item But we need a different peer-group.
\end{itemize}
\vspace{0.5cm}

\begin{framed}
\begin{verbatim}
router bgp 645xx
 neighbor upstream-v6 peer-group
 address-family ipv6 unicast
  neighbor upstream-v6 route-map upstream-in in
  neighbor upstream-v6 route-map upstream-out out
  neighbor upstream-v6 soft-reconfig inbound
  neighbor upstream-v6 activate
 exit-address-family
 neighbor 2001:db8:200:xx::1 remote-as 65550
 neighbor 2001:db8:200:xx::1 peer-group upstream-v6
\end{verbatim}
\end{framed}

Show commands:
\begin{itemize}
  \item show bgp ipv6 summary
  \item show bgp ipv6 neighbor 2001:db8:200:X::1
  \item show bgp ipv6
  \item show bgp ipv6 neighbor 2001:db8:200:X::1 routes
  \item show bgp ipv6 neighbor 2001:db8:200:X::1 received-routes\\
    \emph{why is one prefix you see not accepted?}
  \item show bgp ipv6 neighbor 2001:db8:200:X::1 advertised-routes
\end{itemize}
\end{samepage}
%----------------------------------------------------------------

\clearpage

\section{Setup eBGP}
\subsection{Tasks:}
\begin{itemize}
  \item Define two peer groups for eBGP upstream neighbors: one for IPv4 and one for IPv6
  \item Set up eBGP sessions to AS65550
  \item Check if the sessions come up
  \item Look if you are receiving anything
  \item define (empty) route-maps for in and out
  \item Check again for received prefixes
  \item Try all commands listed below and look for anything unusual.
\end{itemize}

\subsection{To set up eBGP you need to:}
\begin{itemize}
  \item configure two peer-groups for (in this case) upstream eBGP neighbors, one for IPv4 and one for IPv6
  \item configure (empty) filters
  \item configure neighbors which are member of these peer-groups
\end{itemize}
Do IPv4 only first and once it is up and running and you receive a prefix, add IPv6.

\subsection{Information you need:}
\begin{itemize}
  \item Your AS number is 645xx
  \item Your upstream providers AS number is 65550
  \item Have a look at the interface connecting to your upstream. If your IP address is 10.200.1.2/30, then your neighbors IP is 10.200.1.1. For IPv6 your address is something like 2001:db8:200:2::2 and your upstream is 2001:db8:200:2::1.
\end{itemize}

\subsection{To configure eBGP for IPv4 in config mode:}
If you only configure IPv4 you do not to take care of \emph{address family contexts} - see section about IPv6 about details.
\begin{description}
  \item[neighbor <name> peer-group] starts a peer group named \emph{<name>}.
  \item[neighbor <name> route-map <rmname> in/out] filters all prefixes in or out through route-map \emph{<rmname>}. If the route-map is not defined (or if there is a typo in the name) it blocks everything in or out.
  \item[neighbor <name> soft-reconfiguration inbound] allows you to see (via \emph{show bgp ipv4/ipv6 neighbor <address> received-routes}) what the router receives before any incoming filters are processed.
  \item[neighbor <ip-address> remote-as <asnumber>] sets up an neighbor with IP \emph{<ip-address>} and AS \emph{<asnumber>}. This command becomes active as soon as it is entered, so if you want to enter more config items for this peer, you either be quick or you need to shut it down until config is complete.
  \item[neighbor <ip-address> shutdown] shuts down the BGP connection to this neighbor. Useful when you want to take some time configuring.
  \item[neighbor <ip-address> peer-group <name>] makes a neighbor with IP \emph{<ip-address>} a member of the peer group \emph{<name>} (uses the peer-group as a template).
\end{description}
The remote AS is not configured in the peer-group but in the peer-group member, as you might want to re-use the same peer-group for more then one upstream provider.

\subsection{To configure a route-map in config mode:}
\begin{description}
  \item[route-map <name> permit/deny <number>] starts a route-map statement for a named route-map. Each route-map is referenced by \emph{<name>} and statements are processed in order, starting with the lowest \emph{<number>}. Inside each statement there can be zero to multiple \emph{match} and \emph{set} clauses.
  If the statement is evaluated true (all match conditions are true) permit or deny is executed. If not (matches evaluate false) the next statement in order is processed. If there are no statements left, there is an implicit deny at the end.
  \item[match <condition>] An empty/missing \emph{match} is always true. If there are multiples \emph{match} statements, they all must be true for the entry to be true.
  \item[set <parameter> <value>] If all matches are true (or if there are no match statements), all \emph{set} statements are executed, the route-map is terminated and either permit or deny is executed (depending on the value in the statement header).
\end{description}
If the termination happens in a \emph{permit} entry, the prefix currently processed is let through. If it is a \emph{deny} statement, the prefix is discarded.

Route maps have many more possibilities, check your routers documentation or the online documentation of FRRouting at \url{http://docs.frrouting.org/en/latest/routemap.html}


\subsection{Commands to check your eBGP session:}
\begin{description}
\item[show bgp ipv4/ipv6 summary] give you information about your peers
\item[show bgp neighbor <ip-address>] gives you detailed information about BGP neighbor with IP \emph{<ip-address>}. If you omit the IP, it lists all neighbors very detailed (long output).
\item[show bgp ipv4/ipv6] lists all IPv4 prefixes in BGP. Be aware that once you are on a real router connected to the real internet the output can be very long.
\item[show bgp ipv4/ipv6 <prefix>] gives you detailed BGP information about IP  \emph{<prefix>}
\item[show bgp ipv4/ipv6 neighbor <ip-address> routes] shows all valid IPv4 routes received from a specific neighbor (after the filters).
\item[show bgp ipv4/ipv6 neighbor <ip-address> received-routes] shows all IPv4 routes received from a specific neighbor (before filters are applied). Useful for checking if your filters work.
\item[show bgp ipv4/ipv6 neighbor <ip-address> advertised-routes] shows all IPv4 prefixes advertised to a specific neighbor.
\end{description}

\subsection{Configure eBGP for IPv6:}
As IPv6 is younger then the config syntax, they introduced the concept of ``address-families'' contexts. The commands within the address-family context relate to what is \emph{transported} (IPv4- or IPv6-prefixes) \emph{not} to the protocol of the BGP session.

To make things even more confusing, most of the IPv4 related commands are configured by default and not shown in the configuration.

Commands for configuration:
\begin{description}
  \item[bgp ebgp-requires-policy] prevents eBGP sessions without any policy (route-maps) configured from flooding your neighbors by installing a default-deny policy for in and out.
  \item[neighbor <name> peer-group] starts a peer group. Configure outside of any context to define a new peer group.
  \item[neighbor <ipv6-address> remote-as <asnumber>] defines an IPv6 neighbor. Also outside of any context.
  \item[address-family ipv6 unicast] enters context configuration of IPv6 unicast.
  \item[address-family ipv4 unicast] enters context configuration of IPv4 unicast.
  \item[exit-address-family] leaves the current address-family context
  \item[neighbor <name> activate] activates the peer group \emph{<name>} in the current address-family context. Only necessary for IPv6, as peer-groups are activated for IPv4 by default.
  \item[neighbor <name> route-map <rmname> in/out] defines route-maps for the peer-group \emph{name} in the current context. Must be inside IPv6 address-family context for IPv6!
  \item[neighbor <name> soft-reconfiguration inbound] switches on soft-reconfig for the current address-family. Must be defined within the address-family context.
  \item[neighbor <ipv6-address> peer-group <name>] makes a neighbor with IPv6-address \emph{<ipv6-address>} a member of the peer-group \emph{<name>}. Must be configured within IPv6 address-family context.
  \item[no neighbor <ipv6-address> activate] deactivates the session in the given context. For IPv6 transport, this should be configured in IPv4 context to avoid mismatching capabilities.
\end{description}

\subsection{Commands to check BGP sessions:}
\begin{description}
  \item[show bgp summary] shows all BGP sessions of all address families.
  \item[show bgp neighbors] shows detailed information about all BGP neighbors independent of protocol
  \item[show bgp neighbors <address>] show information about one neighbor. \emph{<address>} can be an IPv4- or an IPv6-address.
  \item[show bgp neighbors <address> received-routes] shows received prefixes from a neighbor \emph{before} any filtering.
  \item[show bgp neighbors <address> routes] shows prefixes learned from a neighbor (after filtering)
  \item[show bgp ipv4] shows all IPv4 prefixes in the BGP table
  \item[show bgp ipv6] shows all IPv6 prefixes in the BGP table
\end{description}

\section{Solution}
\begin{minipage}{\textwidth}
\subsection{Solution for FRRouting}
\begin{verbatim}
hostname r0x
router-id 172.16.1.x
!
router bgp 645xx
 no bgp default ipv4-unicast
 bgp ebgp-requires-policy
 neighbor upstream-v4 peer-group
 neighbor upstream-v6 peer-group
 neighbor 10.200.x.1 remote-as 65550
 neighbor 10.200.x.1 peer-group upstream-v4
 neighbor 2001:db8:200:x::1 remote-as 65550
 neighbor 2001:db8:200:x::1 peer-group upstream-v6
 !
 address-family ipv4 unicast
  neighbor upstream-v4 soft-reconfiguration inbound
  neighbor upstream-v4 route-map upstream-in in
  neighbor upstream-v4 route-map upstream-out out
  neighbor upstream-v4 activate
 exit-address-family
 !
 address-family ipv6 unicast
  neighbor upstream-v6 activate
  neighbor upstream-v6 soft-reconfiguration inbound
  neighbor upstream-v6 route-map upstream-in in
  neighbor upstream-v6 route-map upstream-out out
 exit-address-family
!
route-map upstream-out deny 100
route-map upstream-in permit 100
\end{verbatim}
\end{minipage}

\begin{minipage}{\textwidth}
\subsection{Solution for Cisco IOS}
\begin{verbatim}
router bgp 645xx
  neighbor upstream-v4 peer-group
  neighbor upstream-v6 peer-group
  neighbor 10.200.x.1 remote-as 65550
  neighbor 10.200.x.1 peer-group upstream-v4 
  neighbor 2001:db8:200:x::1 remote-as 65550
  neighbor 2001:db8:200:x::1 peer-group upstream-v6
  !
  address-family ipv4
    neighbor upstream-v4 route-map upstream-in in
    neighbor upstream-v4 route-map upstream-out out
    neighbor 10.200.x.1 activate
    no neighbor 2001:db8:200:x::1 activate
  exit-address-family
  !
  address-family ipv6
    neighbor upstream-v6 route-map upstream-in in
    neighbor upstream-v6 route-map upstream-out out 
    neighbor 2001:db8:200:x::1 activate
  exit-address-family
!
route-map upstream-out deny 100
route-map upstream-in permit 100
\end{verbatim}
\end{minipage}

\begin{minipage}{\textwidth}
\subsection{Solution for Mikrotik}
Mikrotik routers do not support something like peer-groups. So each peer needs all parameters\footnote{This configuration has only been tested for syntax.}.
\begin{verbatim}
/system identity
set name=r0x

/routing bgp instance
set default as=645xx router-id=172.16.1.x

/routing bgp peer
add in-filter=upstream-in name=upstreamA-v4 out-filter=upstream-out \
    remote-address=10.200.x.1 remote-as=65550
add address-families=ipv6 in-filter=upstream-in name=upstreamA-v6 out-filter=\
    upstream-out remote-address=2001:db8:200:x::1 remote-as=65550

/routing filter
add action=discard chain=upstream-out
add action=accept chain=upstream-in
\end{verbatim}
\end{minipage}

\begin{minipage}{\textwidth}
\subsection{Solution for Juniper}
Example solution for Juniper routers\footnote{While syntactically correct, this configuration has not been tested}:
\begin{verbatim}
system {
  host-name R0x;
}
routing-options {
    autonomous-system 645xx;
}
protocols {
  bgp {
    local-as 645xx;
    group upstream-v4 {
      import upstream-in;
      family inet {
        unicast;
      }
      export upstream-out;
      neighbor 10.200.x.1 {
        peer-as 65550;
      }
    }
    group upstream-v6 {
      import upstream-in;
      family inet6 {
        unicast;
      }
      export upstream-out;
      neighbor 2001:db8:200:x::1 {
        peer-as 65550;
      }
    }
  }
}
policy-options {
  policy-statement upstream-in {
    then accept;
  }
  policy-statement upstream-out {
    then reject;
  }
}
\end{verbatim}
\end{minipage}

\end{document}
